(* GENLIST v1.0 BIN and SMD file listing utility.  (C) 1997 Anthony
   DiPasquale.  This source may not be distributed commercially, or
   with any modifications.  If modifications are made, please contact
   me.  Please do not distribute any binaries but the original, which
   means anything you compile from this source.  If any parts of this
   source is quoted or borrowed, please give me credit and leave some
   contact info.

   anthony@pce.net
   http://www.pce.net/anthony/emuboard.html

   This will most likley be a final version, unless i get bored and add
   LFN support on a rainy day.

   Some code taken from the S.W.A.G (Sourceware Archives Group) archive.
   Any code from the SWAG archive is copyright by its respective author.
   (Including DeleteFile(); and AllTrim();

   Thanks to Node 99's document section, the uCON source and Sewerat on
   IRC who gave me the info I needed to write up this source. *)


Program GenList;

Uses
  Crt,
  Dos;

Type
  SmallString = String[12];
  ListType = Array[1..1000] of SmallString;


Const
  Debug = false;

Var
  RomName,
  RealName  : string;
  ListFile  : text;
  RomList   : ListType;
  TotalRoms,
  Count     : integer;


function  GetFileSize(FileName: string): longint;
  var
    Srec: SearchRec;
  begin
    FindFirst(FileName, $01+$04+$20, Srec);
    if DosError = 0 then GetFileSize := Srec.Size
    else GetFileSize := 0;
  end;



  function DeleteFile(FN : PathStr) : Boolean;
   var
     Regs : Registers;
   begin
     FN := FN + #0;          { Add NUL chr for DOS }
     Regs.AH := $41;
     Regs.DX := Ofs(FN) + 1; { Add 1 to bypass length byte }
     Regs.DS := Seg(FN);
     MsDos(Regs);
     DeleteFile := NOT (Regs.Flags AND $0 = $0)
  end;

  FUNCTION AllTrim( str : STRING ) : STRING;

     FUNCTION RTrim( s: STRING; c: CHAR ): STRING;
        BEGIN
          WHILE (LENGTH(s) > 0) AND (s[LENGTH(s)] = c) DO DEC(s[0]);
          RTrim := s;
        END;

     FUNCTION LTrim( s: STRING; c: CHAR ): STRING; Assembler;
       ASM
         PUSH   DS
         LDS    SI, s
         XOR    AX, AX
         LODSB
         XCHG   AX, CX
         LES    DI, @Result
         INC    DI
         JCXZ   @@2
         MOV    BL, c
         CLD
         @@1:  LODSB
         CMP    AL, BL
         LOOPE  @@1
         DEC    SI
         INC    CX
         REP    MOVSB

         @@2:  XCHG   AX, DI
         MOV    DI, WORD PTR @Result
         SUB    AX, DI
         DEC    AX
         STOSB
         POP    DS
       END;


     BEGIN
       IF LENGTH( Str ) > 0 THEN
          AllTrim := LTrim(RTrim(str, ' '), ' ')
         ELSE
          AllTrim := Str;
     END;





Procedure ExtractBinName(FileName : string; var GameName : String);
  Var
    Buffer      : Array[1..48] of Char;  { will hold the name feild }
    TempChar    : Char;
    RomFile     : file of char;
    Count       : integer;

  Begin
    Assign(RomFile, FileName);
    Reset(RomFile);
    For Count := 1 to 336 do
      Read(RomFile, TempChar);

    for Count := 1 to 48 do
      Begin
        Read(RomFile, TempChar);
        Buffer[Count] := TempChar;
      End;

    Close(RomFile);

    if Debug then begin WriteLn('Filled the buffer ok.'); WriteLn(Buffer); ReadKey; End;

    GameName := AllTrim(Buffer);

    if Debug then begin WriteLn('Exited procedure ok.'); ReadKey; End;

  End;




Procedure ExtractSMDName(FileName : string; var GameName : string);
  Var
    Buffer1,
    Buffer2     : Array[1..23] of Char;
    Uninterval  : Array[1..46] of Char;
    TempArray   : Array[1..42] of Char;
    TempChar    : Char;
    RomFile     : File of Char;
    Count1,
    Count2      : Integer;

 Begin
   Assign(RomFile, Filename);
   Reset(RomFile);
{   For Count1 := 1 to 679 do read(RomFile,TempChar); }
   Seek(RomFile, 679); { skip the header }
   For Count1 := 1 to 22 do
     Read(RomFile, Buffer1[Count1]);  { first 48 bytes of interval 1 }
{   For Count1 := 1 to 8170 do Read(RomFile, TempChar); }
   Seek(RomFile, 8872); { skip the rest of the interval }
   For Count1 := 1 to 22 do
     Read(RomFile, Buffer2[Count1]);  { read second interval }

   Count2 := 1;
   For Count1 := 1 to 23 do
     Begin
      Uninterval[Count2] := Buffer2[Count1];
      If not (Count1 = 23) then Inc(Count2);
      if not (Count1 = 23) then Uninterval[Count2] := Buffer1[Count1+1];
      If not (Count1 = 23) then Inc(Count2);
     End;

   If Debug then begin WriteLn(Uninterval); readkey; end;

  For Count1 := 1 to 42 do TempArray[Count1] := Uninterval[Count1];
  GameName := AllTrim(TempArray);


  Close(RomFile);
 End;


Procedure GetRomList(var RomList : ListType;  var i : integer);
  Var
    SwapFile  : text;


  Begin
    {$M $4000,0,0 }   { 16K stack, no heap }
    SwapVectors;
    Exec(GetEnv('COMSPEC'), '/C DIR /L /B *.BIN > GENLIST.SWP');
    SwapVectors;
    SwapVectors;
    Exec(GetEnv('COMSPEC'), '/C DIR /L /B *.SMD >> GENLIST.SWP');
    SwapVectors;

    if debug then begin writeln('Stopped.  Take a look at the swap file.'); readkey; end;

    Assign(SwapFile, 'GENLIST.SWP');
    Reset(SwapFile);
    i := 0;
    While Not EOF(Swapfile) do
      Begin
        Inc(i);
        ReadLn(SwapFile, RomList[i]);
      End;
    Close(SwapFile);
    DeleteFile('GENLIST.SWP');
  End;




Begin
  If ParamCount <> 1 then Begin
    WriteLn;
    WriteLn(' GENLIST v1.0 by Anthony DiPasquale');
    WriteLn(' USAGE:  GENLIST.EXE <listfile>');
    WriteLn(' Example: GENLIST MYLIST.TXT');
  End else
    Begin
      WriteLn(' GENLIST v1.0 by Anthony DiPasquale');
      Assign(ListFile, paramstr(1));
      ReWrite(ListFile);
      Write(' Finding ROMs.....');
      GetRomList(RomList, TotalRoms);
      WriteLn('done.  ', TotalRoms, ' found.');
      WriteLn(' Creating ', paramstr(1), ' please wait.');

          WriteLn(ListFile, 'List generated by GENLIST 1.0 by Anthony DiPasquale                        ');
          WriteLn(ListFile);
          WriteLn(ListFile, '.-------------------------------------------------------------------------.');
          WriteLn(ListFile, '|  File Name  |  Size  | Game Title                                       |');
          WriteLn(ListFile, '|-------------+--------+--------------------------------------------------|');

      For Count := 1 to TotalRoms do
        Begin
          RomName := RomList[Count];
            Write(ListFile, '|', RomName:12, ' | ', (GetFileSize(RomName) div 1024):4, 'KB | ');

          If RomName[Length(RomName)] = 'd'
            then ExtractSMDName(RomName, RealName)
            else ExtractBINName(RomName, RealName);



           WriteLn(ListFile, RealName:48, ' |');
        End;

         WriteLn(ListFile, '`-------------------------------------------------------------------------''');
        Close(ListFile);
       WriteLn(' All done!  Thanks for using GENLIST.');
    End;


End.
